//==============================================================================
// FormClient.h
//
// Main form of the SampleService client application
// 
// --vlh--
//==============================================================================

#pragma once

#include "SampleServiceFacade.h"

namespace DotNetClientW {

#pragma region Namespaces
	using namespace System;
	using namespace System::Threading;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Drawing;
	using namespace System::Runtime::InteropServices;
	using namespace System::ServiceProcess;
	using namespace System::Diagnostics;
	using namespace SampleServiceLib;
#pragma endregion

	/// <summary>
	/// Summary for FormClient
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class FormClient : public System::Windows::Forms::Form
	{
	public:
		FormClient(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~FormClient()
		{
			if (components)
			{
				delete components;
			}
		}

#pragma region Form controls
	private: System::Windows::Forms::ToolStripContainer^  toolStripContainer1;
	private: System::Windows::Forms::TabControl^  tabControl1;
	private: System::Windows::Forms::TabPage^  tabPageService;
	private: System::Windows::Forms::TabPage^  tabPagePurify;
	private: System::Windows::Forms::StatusStrip^  statusStrip1;
	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	private: System::Windows::Forms::ToolStripMenuItem^  serviceToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  purifyToolStripMenuItem;
	private: System::Windows::Forms::ToolStrip^  toolStrip1;
	private: System::Windows::Forms::ToolStripButton^  toolStripButtonStart;
	private: System::Windows::Forms::ToolStripStatusLabel^  toolStripStatusLabel;
	private: System::Windows::Forms::ToolStripProgressBar^  toolStripProgressBar;
	private: System::Windows::Forms::ToolStripMenuItem^  startToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  stopToolStripMenuItem;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator1;
	private: System::Windows::Forms::ToolStripMenuItem^  exitClientToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  doABRToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  doUMRToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  doMLKToolStripMenuItem;
	private: System::Windows::Forms::ToolStripButton^  toolStripButtonStop;
	private: System::Windows::Forms::ToolStripButton^  toolStripButtonABR;
	private: System::Windows::Forms::ToolStripButton^  toolStripButtonUMR;
	private: System::Windows::Forms::ToolStripButton^  toolStripButtonMLK;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator2;
	private: System::Windows::Forms::Button^  buttonStopService;
	private: System::Windows::Forms::Panel^  panelServiceButtons;
	private: System::Windows::Forms::Button^  buttonStartService;
	private: System::Windows::Forms::RichTextBox^  richTextBoxSrv;
	private: System::Windows::Forms::RichTextBox^  richTextBoxPfy;
	private: System::Windows::Forms::Panel^  panel1;
	private: System::Windows::Forms::Button^  buttonPurifyDiag;
	private: System::ComponentModel::BackgroundWorker^  backgroundWorker;
	private: System::Windows::Forms::Timer^  timerStatus;
	private: System::ComponentModel::IContainer^  components;
#pragma endregion

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(FormClient::typeid));
			this->toolStripContainer1 = (gcnew System::Windows::Forms::ToolStripContainer());
			this->tabControl1 = (gcnew System::Windows::Forms::TabControl());
			this->tabPageService = (gcnew System::Windows::Forms::TabPage());
			this->richTextBoxSrv = (gcnew System::Windows::Forms::RichTextBox());
			this->panelServiceButtons = (gcnew System::Windows::Forms::Panel());
			this->buttonStopService = (gcnew System::Windows::Forms::Button());
			this->buttonStartService = (gcnew System::Windows::Forms::Button());
			this->tabPagePurify = (gcnew System::Windows::Forms::TabPage());
			this->richTextBoxPfy = (gcnew System::Windows::Forms::RichTextBox());
			this->panel1 = (gcnew System::Windows::Forms::Panel());
			this->buttonPurifyDiag = (gcnew System::Windows::Forms::Button());
			this->statusStrip1 = (gcnew System::Windows::Forms::StatusStrip());
			this->toolStripStatusLabel = (gcnew System::Windows::Forms::ToolStripStatusLabel());
			this->toolStripProgressBar = (gcnew System::Windows::Forms::ToolStripProgressBar());
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->serviceToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->startToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->stopToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->exitClientToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->purifyToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->doABRToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->doUMRToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->doMLKToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStrip1 = (gcnew System::Windows::Forms::ToolStrip());
			this->toolStripButtonStart = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolStripButtonStop = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolStripSeparator2 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->toolStripButtonABR = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolStripButtonUMR = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolStripButtonMLK = (gcnew System::Windows::Forms::ToolStripButton());
			this->backgroundWorker = (gcnew System::ComponentModel::BackgroundWorker());
			this->timerStatus = (gcnew System::Windows::Forms::Timer(this->components));
			this->toolStripContainer1->ContentPanel->SuspendLayout();
			this->toolStripContainer1->TopToolStripPanel->SuspendLayout();
			this->toolStripContainer1->SuspendLayout();
			this->tabControl1->SuspendLayout();
			this->tabPageService->SuspendLayout();
			this->panelServiceButtons->SuspendLayout();
			this->tabPagePurify->SuspendLayout();
			this->panel1->SuspendLayout();
			this->statusStrip1->SuspendLayout();
			this->menuStrip1->SuspendLayout();
			this->toolStrip1->SuspendLayout();
			this->SuspendLayout();
			// 
			// toolStripContainer1
			// 
			// 
			// toolStripContainer1.ContentPanel
			// 
			this->toolStripContainer1->ContentPanel->Controls->Add(this->tabControl1);
			this->toolStripContainer1->ContentPanel->Controls->Add(this->statusStrip1);
			this->toolStripContainer1->ContentPanel->Size = System::Drawing::Size(392, 317);
			this->toolStripContainer1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->toolStripContainer1->Location = System::Drawing::Point(0, 0);
			this->toolStripContainer1->Name = L"toolStripContainer1";
			this->toolStripContainer1->Size = System::Drawing::Size(392, 366);
			this->toolStripContainer1->TabIndex = 0;
			this->toolStripContainer1->Text = L"toolStripContainer1";
			// 
			// toolStripContainer1.TopToolStripPanel
			// 
			this->toolStripContainer1->TopToolStripPanel->Controls->Add(this->menuStrip1);
			this->toolStripContainer1->TopToolStripPanel->Controls->Add(this->toolStrip1);
			// 
			// tabControl1
			// 
			this->tabControl1->Controls->Add(this->tabPageService);
			this->tabControl1->Controls->Add(this->tabPagePurify);
			this->tabControl1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->tabControl1->Location = System::Drawing::Point(0, 0);
			this->tabControl1->Name = L"tabControl1";
			this->tabControl1->SelectedIndex = 0;
			this->tabControl1->Size = System::Drawing::Size(392, 295);
			this->tabControl1->TabIndex = 1;
			// 
			// tabPageService
			// 
			this->tabPageService->Controls->Add(this->richTextBoxSrv);
			this->tabPageService->Controls->Add(this->panelServiceButtons);
			this->tabPageService->Location = System::Drawing::Point(4, 22);
			this->tabPageService->Name = L"tabPageService";
			this->tabPageService->Padding = System::Windows::Forms::Padding(3);
			this->tabPageService->Size = System::Drawing::Size(384, 269);
			this->tabPageService->TabIndex = 0;
			this->tabPageService->Text = L"Service";
			this->tabPageService->UseVisualStyleBackColor = true;
			// 
			// richTextBoxSrv
			// 
			this->richTextBoxSrv->BackColor = System::Drawing::SystemColors::Window;
			this->richTextBoxSrv->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->richTextBoxSrv->Dock = System::Windows::Forms::DockStyle::Fill;
			this->richTextBoxSrv->Location = System::Drawing::Point(3, 37);
			this->richTextBoxSrv->Name = L"richTextBoxSrv";
			this->richTextBoxSrv->ReadOnly = true;
			this->richTextBoxSrv->Size = System::Drawing::Size(378, 229);
			this->richTextBoxSrv->TabIndex = 2;
			this->richTextBoxSrv->Text = L"";
			// 
			// panelServiceButtons
			// 
			this->panelServiceButtons->Controls->Add(this->buttonStopService);
			this->panelServiceButtons->Controls->Add(this->buttonStartService);
			this->panelServiceButtons->Dock = System::Windows::Forms::DockStyle::Top;
			this->panelServiceButtons->Location = System::Drawing::Point(3, 3);
			this->panelServiceButtons->Name = L"panelServiceButtons";
			this->panelServiceButtons->Size = System::Drawing::Size(378, 34);
			this->panelServiceButtons->TabIndex = 1;
			// 
			// buttonStopService
			// 
			this->buttonStopService->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"buttonStopService.Image")));
			this->buttonStopService->ImageAlign = System::Drawing::ContentAlignment::MiddleLeft;
			this->buttonStopService->Location = System::Drawing::Point(75, 3);
			this->buttonStopService->Name = L"buttonStopService";
			this->buttonStopService->Size = System::Drawing::Size(64, 27);
			this->buttonStopService->TabIndex = 0;
			this->buttonStopService->Text = L"Stop";
			this->buttonStopService->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			this->buttonStopService->UseVisualStyleBackColor = true;
			this->buttonStopService->Click += gcnew System::EventHandler(this, &FormClient::buttonStopService_Click);
			// 
			// buttonStartService
			// 
			this->buttonStartService->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"buttonStartService.Image")));
			this->buttonStartService->ImageAlign = System::Drawing::ContentAlignment::MiddleLeft;
			this->buttonStartService->Location = System::Drawing::Point(5, 3);
			this->buttonStartService->Name = L"buttonStartService";
			this->buttonStartService->Size = System::Drawing::Size(64, 27);
			this->buttonStartService->TabIndex = 0;
			this->buttonStartService->Text = L"Start";
			this->buttonStartService->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			this->buttonStartService->UseVisualStyleBackColor = true;
			this->buttonStartService->Click += gcnew System::EventHandler(this, &FormClient::buttonStartService_Click);
			// 
			// tabPagePurify
			// 
			this->tabPagePurify->Controls->Add(this->richTextBoxPfy);
			this->tabPagePurify->Controls->Add(this->panel1);
			this->tabPagePurify->Location = System::Drawing::Point(4, 22);
			this->tabPagePurify->Name = L"tabPagePurify";
			this->tabPagePurify->Padding = System::Windows::Forms::Padding(3);
			this->tabPagePurify->Size = System::Drawing::Size(384, 269);
			this->tabPagePurify->TabIndex = 1;
			this->tabPagePurify->Text = L"Purify";
			this->tabPagePurify->UseVisualStyleBackColor = true;
			// 
			// richTextBoxPfy
			// 
			this->richTextBoxPfy->BackColor = System::Drawing::SystemColors::Window;
			this->richTextBoxPfy->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->richTextBoxPfy->Dock = System::Windows::Forms::DockStyle::Fill;
			this->richTextBoxPfy->Location = System::Drawing::Point(3, 45);
			this->richTextBoxPfy->Name = L"richTextBoxPfy";
			this->richTextBoxPfy->ReadOnly = true;
			this->richTextBoxPfy->Size = System::Drawing::Size(378, 221);
			this->richTextBoxPfy->TabIndex = 3;
			this->richTextBoxPfy->Text = L"";
			// 
			// panel1
			// 
			this->panel1->Controls->Add(this->buttonPurifyDiag);
			this->panel1->Dock = System::Windows::Forms::DockStyle::Top;
			this->panel1->Location = System::Drawing::Point(3, 3);
			this->panel1->Name = L"panel1";
			this->panel1->Size = System::Drawing::Size(378, 42);
			this->panel1->TabIndex = 4;
			// 
			// buttonPurifyDiag
			// 
			this->buttonPurifyDiag->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"buttonPurifyDiag.Image")));
			this->buttonPurifyDiag->ImageAlign = System::Drawing::ContentAlignment::MiddleLeft;
			this->buttonPurifyDiag->Location = System::Drawing::Point(5, 3);
			this->buttonPurifyDiag->Name = L"buttonPurifyDiag";
			this->buttonPurifyDiag->Size = System::Drawing::Size(94, 36);
			this->buttonPurifyDiag->TabIndex = 0;
			this->buttonPurifyDiag->Text = L"Diagnose";
			this->buttonPurifyDiag->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			this->buttonPurifyDiag->UseVisualStyleBackColor = true;
			this->buttonPurifyDiag->Click += gcnew System::EventHandler(this, &FormClient::buttonPurifyDiag_Click);
			// 
			// statusStrip1
			// 
			this->statusStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->toolStripStatusLabel, 
				this->toolStripProgressBar});
			this->statusStrip1->Location = System::Drawing::Point(0, 295);
			this->statusStrip1->Name = L"statusStrip1";
			this->statusStrip1->RenderMode = System::Windows::Forms::ToolStripRenderMode::Professional;
			this->statusStrip1->Size = System::Drawing::Size(392, 22);
			this->statusStrip1->TabIndex = 0;
			this->statusStrip1->Text = L"statusStrip1";
			// 
			// toolStripStatusLabel
			// 
			this->toolStripStatusLabel->AutoSize = false;
			this->toolStripStatusLabel->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->toolStripStatusLabel->Name = L"toolStripStatusLabel";
			this->toolStripStatusLabel->Size = System::Drawing::Size(275, 17);
			this->toolStripStatusLabel->Spring = true;
			this->toolStripStatusLabel->Text = L"Status";
			this->toolStripStatusLabel->TextAlign = System::Drawing::ContentAlignment::MiddleLeft;
			// 
			// toolStripProgressBar
			// 
			this->toolStripProgressBar->Alignment = System::Windows::Forms::ToolStripItemAlignment::Right;
			this->toolStripProgressBar->Name = L"toolStripProgressBar";
			this->toolStripProgressBar->Size = System::Drawing::Size(100, 16);
			this->toolStripProgressBar->Step = 1;
			this->toolStripProgressBar->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			// 
			// menuStrip1
			// 
			this->menuStrip1->Dock = System::Windows::Forms::DockStyle::None;
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->serviceToolStripMenuItem, 
				this->purifyToolStripMenuItem});
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(392, 24);
			this->menuStrip1->TabIndex = 1;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// serviceToolStripMenuItem
			// 
			this->serviceToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(4) {this->startToolStripMenuItem, 
				this->stopToolStripMenuItem, this->toolStripSeparator1, this->exitClientToolStripMenuItem});
			this->serviceToolStripMenuItem->Name = L"serviceToolStripMenuItem";
			this->serviceToolStripMenuItem->Size = System::Drawing::Size(54, 20);
			this->serviceToolStripMenuItem->Text = L"Ser&vice";
			// 
			// startToolStripMenuItem
			// 
			this->startToolStripMenuItem->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"startToolStripMenuItem.Image")));
			this->startToolStripMenuItem->Name = L"startToolStripMenuItem";
			this->startToolStripMenuItem->Size = System::Drawing::Size(133, 22);
			this->startToolStripMenuItem->Text = L"&Start";
			this->startToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormClient::startToolStripMenuItem_Click);
			// 
			// stopToolStripMenuItem
			// 
			this->stopToolStripMenuItem->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"stopToolStripMenuItem.Image")));
			this->stopToolStripMenuItem->Name = L"stopToolStripMenuItem";
			this->stopToolStripMenuItem->Size = System::Drawing::Size(133, 22);
			this->stopToolStripMenuItem->Text = L"S&top";
			this->stopToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormClient::stopToolStripMenuItem_Click);
			// 
			// toolStripSeparator1
			// 
			this->toolStripSeparator1->Name = L"toolStripSeparator1";
			this->toolStripSeparator1->Size = System::Drawing::Size(130, 6);
			// 
			// exitClientToolStripMenuItem
			// 
			this->exitClientToolStripMenuItem->Name = L"exitClientToolStripMenuItem";
			this->exitClientToolStripMenuItem->Size = System::Drawing::Size(133, 22);
			this->exitClientToolStripMenuItem->Text = L"E&xit Client";
			this->exitClientToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormClient::exitClientToolStripMenuItem_Click);
			// 
			// purifyToolStripMenuItem
			// 
			this->purifyToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->doABRToolStripMenuItem, 
				this->doUMRToolStripMenuItem, this->doMLKToolStripMenuItem});
			this->purifyToolStripMenuItem->Name = L"purifyToolStripMenuItem";
			this->purifyToolStripMenuItem->Size = System::Drawing::Size(66, 20);
			this->purifyToolStripMenuItem->Text = L"&PurifyPlus";
			// 
			// doABRToolStripMenuItem
			// 
			this->doABRToolStripMenuItem->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"doABRToolStripMenuItem.Image")));
			this->doABRToolStripMenuItem->Name = L"doABRToolStripMenuItem";
			this->doABRToolStripMenuItem->Size = System::Drawing::Size(123, 22);
			this->doABRToolStripMenuItem->Text = L"Do &ABR";
			this->doABRToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormClient::buttonDoABR_Click);
			// 
			// doUMRToolStripMenuItem
			// 
			this->doUMRToolStripMenuItem->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"doUMRToolStripMenuItem.Image")));
			this->doUMRToolStripMenuItem->Name = L"doUMRToolStripMenuItem";
			this->doUMRToolStripMenuItem->Size = System::Drawing::Size(123, 22);
			this->doUMRToolStripMenuItem->Text = L"Do &UMR";
			this->doUMRToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormClient::buttonDoUMR_Click);
			// 
			// doMLKToolStripMenuItem
			// 
			this->doMLKToolStripMenuItem->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"doMLKToolStripMenuItem.Image")));
			this->doMLKToolStripMenuItem->Name = L"doMLKToolStripMenuItem";
			this->doMLKToolStripMenuItem->Size = System::Drawing::Size(123, 22);
			this->doMLKToolStripMenuItem->Text = L"Do &MLK";
			this->doMLKToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormClient::buttonDoMLK_Click);
			// 
			// toolStrip1
			// 
			this->toolStrip1->Dock = System::Windows::Forms::DockStyle::None;
			this->toolStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(6) {this->toolStripButtonStart, 
				this->toolStripButtonStop, this->toolStripSeparator2, this->toolStripButtonABR, this->toolStripButtonUMR, this->toolStripButtonMLK});
			this->toolStrip1->Location = System::Drawing::Point(3, 24);
			this->toolStrip1->Name = L"toolStrip1";
			this->toolStrip1->Size = System::Drawing::Size(133, 25);
			this->toolStrip1->TabIndex = 0;
			// 
			// toolStripButtonStart
			// 
			this->toolStripButtonStart->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolStripButtonStart->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButtonStart.Image")));
			this->toolStripButtonStart->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->toolStripButtonStart->Name = L"toolStripButtonStart";
			this->toolStripButtonStart->Size = System::Drawing::Size(23, 22);
			this->toolStripButtonStart->Text = L"Start";
			this->toolStripButtonStart->Click += gcnew System::EventHandler(this, &FormClient::buttonStartService_Click);
			// 
			// toolStripButtonStop
			// 
			this->toolStripButtonStop->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolStripButtonStop->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButtonStop.Image")));
			this->toolStripButtonStop->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->toolStripButtonStop->Name = L"toolStripButtonStop";
			this->toolStripButtonStop->Size = System::Drawing::Size(23, 22);
			this->toolStripButtonStop->Text = L"Stop";
			this->toolStripButtonStop->Click += gcnew System::EventHandler(this, &FormClient::buttonStopService_Click);
			// 
			// toolStripSeparator2
			// 
			this->toolStripSeparator2->Name = L"toolStripSeparator2";
			this->toolStripSeparator2->Size = System::Drawing::Size(6, 25);
			// 
			// toolStripButtonABR
			// 
			this->toolStripButtonABR->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolStripButtonABR->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButtonABR.Image")));
			this->toolStripButtonABR->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->toolStripButtonABR->Name = L"toolStripButtonABR";
			this->toolStripButtonABR->Size = System::Drawing::Size(23, 22);
			this->toolStripButtonABR->Text = L"ABR";
			this->toolStripButtonABR->Click += gcnew System::EventHandler(this, &FormClient::buttonDoABR_Click);
			// 
			// toolStripButtonUMR
			// 
			this->toolStripButtonUMR->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolStripButtonUMR->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButtonUMR.Image")));
			this->toolStripButtonUMR->ImageTransparentColor = System::Drawing::Color::Magenta;
			this->toolStripButtonUMR->Name = L"toolStripButtonUMR";
			this->toolStripButtonUMR->Size = System::Drawing::Size(23, 22);
			this->toolStripButtonUMR->Text = L"UMR";
			this->toolStripButtonUMR->Click += gcnew System::EventHandler(this, &FormClient::buttonDoUMR_Click);
			// 
			// toolStripButtonMLK
			// 
			this->toolStripButtonMLK->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->toolStripButtonMLK->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"toolStripButtonMLK.Image")));
			this->toolStripButtonMLK->ImageTransparentColor = System::Drawing::Color::Transparent;
			this->toolStripButtonMLK->Name = L"toolStripButtonMLK";
			this->toolStripButtonMLK->Size = System::Drawing::Size(23, 22);
			this->toolStripButtonMLK->Text = L"MLK";
			this->toolStripButtonMLK->ToolTipText = L"Memory Leak";
			this->toolStripButtonMLK->Click += gcnew System::EventHandler(this, &FormClient::buttonDoMLK_Click);
			// 
			// backgroundWorker
			// 
			this->backgroundWorker->WorkerSupportsCancellation = true;
			this->backgroundWorker->DoWork += gcnew System::ComponentModel::DoWorkEventHandler(this, &FormClient::OnBackgroundRequest);
			this->backgroundWorker->RunWorkerCompleted += gcnew System::ComponentModel::RunWorkerCompletedEventHandler(this, &FormClient::backgroundWorker_RunWorkerCompleted);
			// 
			// timerStatus
			// 
			this->timerStatus->Tick += gcnew System::EventHandler(this, &FormClient::timerStatus_Tick);
			// 
			// FormClient
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(392, 366);
			this->Controls->Add(this->toolStripContainer1);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->MainMenuStrip = this->menuStrip1;
			this->Name = L"FormClient";
			this->Text = L"Sample Service Client";
			this->Load += gcnew System::EventHandler(this, &FormClient::FormClient_Load);
			this->toolStripContainer1->ContentPanel->ResumeLayout(false);
			this->toolStripContainer1->ContentPanel->PerformLayout();
			this->toolStripContainer1->TopToolStripPanel->ResumeLayout(false);
			this->toolStripContainer1->TopToolStripPanel->PerformLayout();
			this->toolStripContainer1->ResumeLayout(false);
			this->toolStripContainer1->PerformLayout();
			this->tabControl1->ResumeLayout(false);
			this->tabPageService->ResumeLayout(false);
			this->panelServiceButtons->ResumeLayout(false);
			this->tabPagePurify->ResumeLayout(false);
			this->panel1->ResumeLayout(false);
			this->statusStrip1->ResumeLayout(false);
			this->statusStrip1->PerformLayout();
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->toolStrip1->ResumeLayout(false);
			this->toolStrip1->PerformLayout();
			this->ResumeLayout(false);

		}
#pragma endregion

#pragma region Private Implementation

	private: SampleServiceFacade^ m_sampleService;	// Sample Service Facade 
													//	Set to nullptr if the service 
													//  is not installed
	private: unsigned m_uTimeout;					// Default timeout = 10 s.
	private: bool m_bStarting;						// True if starting

	// Log line in the Purify log
	private: System::Void LogPfy(String^ i_str)
			 {
				 richTextBoxPfy->Text += i_str + "\n";
			 }
	// Log line in the Service log
	private: System::Void LogSrv(String^ i_str)
			 {
				 richTextBoxSrv->Text += i_str + "\n"; 
			 }

	// Service not present.
	// Log the problem and disable service controls.
	private: System::Void ServiceNotPresent()
			 {
				 LogSrv(
					 "Service \"SampleService\" not present on this machine.\n"
					 "To install service run the following command\n"
					 "SampleService -service\n"
					 "After service is installed, restatrt the client\n"
					 );

	 				 startToolStripMenuItem->Enabled = false;
					 purifyToolStripMenuItem->Enabled = false;
					 buttonStartService->Enabled = false;
					 toolStripButtonABR->Enabled = false;
					 toolStripButtonMLK->Enabled = false;
					 toolStripButtonUMR->Enabled = false;
					 toolStripButtonStart->Enabled = false;
					 buttonStartService->Enabled = false;
					 toolStripButtonStop->Enabled = false;
					 buttonStopService->Enabled = false;
			 }

	private: System::Void TogglePurify(bool i_bEnable)
			 {
					 purifyToolStripMenuItem->Enabled = i_bEnable;
					 buttonStartService->Enabled = i_bEnable;
					 toolStripButtonABR->Enabled = i_bEnable;
					 toolStripButtonMLK->Enabled = i_bEnable;
					 toolStripButtonUMR->Enabled = i_bEnable;
			 }

	private: System::Void ToggleServiceStart(bool i_bEnable)
			 {
					 toolStripButtonStart->Enabled   = i_bEnable;
					 buttonStartService->Enabled     = i_bEnable;
					 startToolStripMenuItem->Enabled = i_bEnable;
					 toolStripButtonStop->Enabled    = !i_bEnable;
					 buttonStopService->Enabled      = !i_bEnable;
					 stopToolStripMenuItem->Enabled  = !i_bEnable;
			 }

	// Update the UI controls depending on the service status.
	private: System::Void UpdateStatus()
			 {
				 String^ strStat = m_sampleService->StatusString;
				 toolStripStatusLabel->Text = strStat;
				 LogSrv("Service status: " + strStat);
				 timerStatus->Enabled = false;
				 bool bRunning = m_sampleService->Status == ServiceControllerStatus::Running;
				 bool bInstrumented = m_sampleService->IsInstrumented() != enInstrumented::INSTRUMENTED_NOTHING;
				 TogglePurify(bRunning && bInstrumented);
 				 ToggleServiceStart(!bRunning);
				 toolStripProgressBar->Value = bRunning ? 100 : 0;
			 }

	// Start the service
	private: System::Void StartService()
			 {
					try
					{
						m_bStarting = true;
						timerStatus->Enabled = true;
						toolStripButtonStart->Enabled = false;
						buttonStartService->Enabled = false;
						startToolStripMenuItem->Enabled = false;
						backgroundWorker->RunWorkerAsync("Start");		
					}
					catch(Exception^ ex)
					{
						LogSrv(ex->Message);
					}
			 }

	// Stop the service
	private: System::Void StopService()
			 {
					try
					{
						m_bStarting = false;
						timerStatus->Enabled = true;
						toolStripButtonStop->Enabled = false;
						buttonStopService->Enabled = false;
						stopToolStripMenuItem->Enabled = false;
						backgroundWorker->RunWorkerAsync("Stop");
					}
					catch(Exception^ ex)
					{
						LogSrv(ex->Message);
					}
			 }

	// Trigger "beyond Array Boundary Read" in the instrumented service
	private: System::Void DoABR()
			 {
				 m_sampleService->DoABR();
				 LogSrv("Triggered ABR");
			 }
	
	// Trigger "Uninitialized Memory Read" in the instrumented service
	private: System::Void DoUMR()
			 {
				 m_sampleService->DoUMR();
				 LogSrv("Triggered UMR");
			 }

	// Trigger "Memory Leak" in the instrumented service
	private: System::Void DoMLK()
			 {
				 m_sampleService->DoMLK();
				 LogSrv("Triggered MLK");
			 }

	// Diagnose the service
	private: System::Void Diagnose()
			 {
				 try
				 {
					 // Get process info
					 Process^ procClient = Process::GetCurrentProcess();
					 array<Process^>^ procService = Process::GetProcessesByName("SampleService");
					 array<Process^>^ procPurifyW = Process::GetProcessesByName("PurifyW");

					 // Clear log
					 this->richTextBoxPfy->Text = "";
					// Run Purify diagnostic
					DiagnosePurify(procClient, procPurifyW);
					 // Run SampleService diagnostic
					DiagnoseSampleService(procClient, procService);
				 }
				 catch(Exception ^ ex)
				 {
					 LogPfy(ex->ToString());
				 }
			 }

	// Diagnose Purify Server
	public: System::Void DiagnosePurify(Process^ procClient, array<Process^>^ procPurifyW )
					 {
						 LogPfy("Current Session ID = " + procClient->SessionId);
						 if(procPurifyW->Length == 0)
						 {
							 LogPfy("Purify Server is not running");
						 }
						 else
						 {
							 for(int n = 0; n < procPurifyW->Length; n++)
							 {
								 LogPfy("Purify Server: " +  procPurifyW[n]->ProcessName + 
									 "[" + procPurifyW[n]->Id + "] "
									 + "SessionId: " + procPurifyW[n]->SessionId);
							 }

						 }
					 }
	// Diagnose the sample service
	public: System::Void DiagnoseSampleService(Process^ procClient, array<Process^>^ procService)
				 {
					 if(m_sampleService->Status == ServiceControllerStatus::Running)
					 {
						 bool bInstrumented = m_sampleService->IsInstrumented() != enInstrumented::INSTRUMENTED_NOTHING;
						 String^ strGlobalName = "PURE_USE_GLOBAL_NAMESPACE";
						 String^ strGlobalValue = m_sampleService->GetEnv(strGlobalName);
						 String^ strInstrumented = String::Format("SampleService is {0} instrumented {1}"
												  , bInstrumented ? "" : " not "
												  , bInstrumented ? " with " : "");
						 switch (m_sampleService->IsInstrumented())
						 {
						 case enInstrumented::INSTRUMENTED_PURIFY :
							 strInstrumented += "Purify";
							 break;
						 case enInstrumented::INSTRUMENTED_COVERAGE:
							 strInstrumented += "Coverage";
							 break;
						 case enInstrumented::INSTRUMENTED_QUANTIFY:
							 strInstrumented += "Quantify";
							 break;
						 }
						 
						 LogPfy(strInstrumented);
						 if(procClient->SessionId != 0 && strGlobalValue == nullptr)
						 {
							 LogPfy("You are running in a session # " + procClient->SessionId);
							 LogPfy("Add " + strGlobalName + " = 1 to the SYSTEM environment");
							 LogPfy("And reboot");
						 }
						 if(strGlobalValue == nullptr)
						 {
							 LogPfy(strGlobalName + " not set");
						 }
						 else
						 {
							 LogPfy(strGlobalName + " = " + strGlobalValue);
						 }
					 }
					 else
					 {
						 LogPfy("SampleService is not running");
					 }
				 }

#pragma endregion

#pragma region Event Handlers

	// Form load event
	private: System::Void FormClient_Load(System::Object^  sender, System::EventArgs^  e) 
			 {
				 try
				 {
					 // Default timeout = 10000 ms (10s)
					 m_uTimeout = 10000;
					 // Get the service facade
					 m_sampleService = gcnew SampleServiceFacade();
					 // Run the initial diagnostic
					 Diagnose();
					 // Update status
					 UpdateStatus();
				 }
				 catch(Exception^ ex)
				 {
					 ServiceNotPresent();
					 LogSrv(ex->Message);
				 }

			 }

    // Progress update timer
	private: System::Void timerStatus_Tick(System::Object^  sender, System::EventArgs^  e) 
			 {
				 if(m_bStarting && toolStripProgressBar->Value < toolStripProgressBar->Maximum)
					 toolStripProgressBar->Value++;
				 else if(toolStripProgressBar->Value > toolStripProgressBar->Minimum)
					 toolStripProgressBar->Value--;
			 }

	// Backround worker controls service on a background thread, 
	// so the main UI thread doesn't stop responding
	// 

	// Background work completed
    //
	private: System::Void backgroundWorker_RunWorkerCompleted(System::Object^  sender, System::ComponentModel::RunWorkerCompletedEventArgs^  e) 
			 {
				 try
				 {
					 // Disable progress update
					 timerStatus->Enabled = false;

					 // Check if exception was processed by the background worker
					 if(e->Error != nullptr)
					 {
						 LogSrv(e->Error->ToString());
					 }
					 // Check the cancelation status
					 else if(e->Cancelled)
					 {
						 LogSrv("Canceled");
					 }
					 // Update the service status
					 UpdateStatus();
				 }
				 catch(Exception ^e)
				 {
					 LogSrv(e->ToString());
				 }
			 }


	// Background request processor for the service control.
    // Keep in mind this code is running on a separate thread.
	private: System::Void OnBackgroundRequest(System::Object^  sender, System::ComponentModel::DoWorkEventArgs^  e) 
			 {
				 if(m_sampleService != nullptr)
				 {
					 if(e->Argument->ToString() == "Start")
					 {
						 // Submit the bcakground request to start the service
						 m_sampleService->Start(m_uTimeout);
					 }
					 else if(e->Argument->ToString() == "Stop")
					 {
						 // Submit the bcakground request to stop the service
						 m_sampleService->Stop(m_uTimeout);
						 // After service stopped, it is a good idea 
						 // to wait a second or two before you start it again.
						 // Otherwice it becomes unstable.
						 Thread::Sleep(2000);
					 }
				 }
			 }

	// ABR Button click
	private: System::Void buttonDoABR_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 DoABR();
			 }
	//UMR Button click
	private: System::Void buttonDoUMR_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 DoUMR();
			 }
	// MLK Button click
	private: System::Void buttonDoMLK_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 DoMLK();
			 }
	// Start button click
	private: System::Void buttonStartService_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 StartService();
			 }
	// Stop button click
	private: System::Void buttonStopService_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 StopService();
			 }
	// Start menu item
	private: System::Void startToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 StartService();
			 }
	// Stop menu item
	private: System::Void stopToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 StopService();
			 }
	// Exit
	private: System::Void exitClientToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 if(Application::AllowQuit)
					 Application::Exit();
			 }

	// Diagnostic button
	private: System::Void buttonPurifyDiag_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
				 Diagnose();
			 }
#pragma endregion
};
}

