////////////////////////////////////////////////////////////////////////////////
// BadActX ActiveX Demonstration Program For Purify
//
// | Licensed Materials - Use restricted, please refer to the "Samples" terms
// | and conditions in the IBM International Program License Agreement (IPLA).  
// (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//
// Authors: Alan S. Cooper, Sean Echevarria
// Venki Muthanna and John Birchfield
////////////////////////////////////////////////////////////////////////////////
// Typical Disclaimer: This FAQ is copyright (c) 1997 by Tom Armstrong
// (tom@widgetware.com). You have the right to copy and distribute this file 
// in any way you see fit as long as this paragraph is included with the 
// distribution. No warranties or claims are made as to the validity of the 
// information contained herein. So use it at your own risk.
////////////////////////////////////////////////////////////////////////////////
//
// BadActXGridCtrl.cpp: implementation of the CMyGridCtrl class.

#include "stdafx.h"
#include "BadActXGridCtrl.h"	// for class CMyGridCtrl
#include "resource.h"			// for IDC_MSFLEXGRID

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMyGridCtrl::CMyGridCtrl()
{

}

CMyGridCtrl::~CMyGridCtrl()
{

}

BEGIN_EVENTSINK_MAP(CMyGridCtrl, CMSFlexGrid)
    //{{AFX_EVENTSINK_MAP(CMyBadActXCtrl)
	ON_EVENT(CMyGridCtrl, IDC_MSFLEXGRID, 69,	 OnSelChangeMsFlexGrid, VTS_NONE)
	ON_EVENT(CMyGridCtrl, IDC_MSFLEXGRID, -600,  OnClickMsFlexGrid, VTS_NONE)
	ON_EVENT(CMyGridCtrl, IDC_MSFLEXGRID, -601,  OnDblClickMsFlexGrid, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CMyGridCtrl::OnSelChangeMsFlexGrid() 
{
	CWnd* pParentWnd = GetParent();
	::SendMessage(pParentWnd->GetSafeHwnd(), IDC_IMPORTED_SEL_CHANGE, 0, 0);
}

void CMyGridCtrl::OnClickMsFlexGrid() 
{
	CWnd* pParentWnd = GetParent();
	::SendMessage(pParentWnd->GetSafeHwnd(), IDC_IMPORTED_SINGLE_CLICK, 0, 0);
}

void CMyGridCtrl::OnDblClickMsFlexGrid() 
{
	CWnd* pParentWnd = GetParent();
	::SendMessage(pParentWnd->GetSafeHwnd(), IDC_IMPORTED_DBL_CLICK, 0, 0);
}