//*
//* selldlg.cpp
//*
//* | Licensed Materials - Use restricted, please refer to the "Samples" terms
//* | and conditions in the IBM International Program License Agreement (IPLA).  
//* (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//*

// selldlg.cpp : implementation file
//

#include "stdafx.h"
#include "Stock.h"
#include "StockDoc.h"
#include "selldlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSellDlg dialog


CSellDlg::CSellDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSellDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSellDlg)
	m_Symbol = _T("");
	//}}AFX_DATA_INIT
}


void CSellDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSellDlg)
	DDX_LBString(pDX, IDC_SYMBOL_LIST, m_Symbol);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSellDlg, CDialog)
	//{{AFX_MSG_MAP(CSellDlg)
	ON_LBN_DBLCLK(IDC_SYMBOL_LIST, OnDblclkSymbolList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//CSellDlg::OnInitDialog - fills the list box with the available
// stock symbols.
BOOL CSellDlg::OnInitDialog ()
{
int i;
CListBox* pLB;
	if (CDialog::OnInitDialog ())
		{
		pLB = (CListBox*) GetDlgItem (IDC_SYMBOL_LIST);
		pLB->SetColumnWidth(pLB->GetItemHeight(0) *5);
		for (i = 0; i < m_dpPortfolio->m_Portfolio.GetSize (); i++)
			pLB->AddString (StockSymbols.GetName (m_dpPortfolio->m_Portfolio [i].m_Symbol)); 
		pLB->SetCurSel (0);
		return TRUE;
		}
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// CSellDlg message handlers

//CSellDlg::OnDblclkSymbolList - causes dialog to close and return IDOK
// when the user double clicks in the symbol list box.
void CSellDlg::OnDblclkSymbolList() 
{
	if (UpdateData (TRUE)) EndDialog (IDOK);	
}
