//*
//* symdlg.cpp
//*
//* | Licensed Materials - Use restricted, please refer to the "Samples" terms
//* | and conditions in the IBM International Program License Agreement (IPLA).  
//* (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//*

// symdlg.cpp : implementation file
//

#include "stdafx.h"
#include "Stock.h"
#include "symdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSymDlg dialog


CSymDlg::CSymDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSymDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSymDlg)
	m_Symbol = _T("");
	//}}AFX_DATA_INIT
}

//CSymDlg::OnInitDialog - fills the list box with the available
// stock symbols.
BOOL CSymDlg::OnInitDialog ()
{
char* cp;
CListBox* pLB;
	if (CDialog::OnInitDialog ())
		{
		pLB = (CListBox*) GetDlgItem (IDC_SYMBOL_LIST);
		pLB->SetColumnWidth(pLB->GetItemHeight(0) *5);
		for (StockSymbols.Restart (); cp = StockSymbols.GetNext (); 
			pLB->AddString (cp) );
		pLB->SetCurSel (0);
		return TRUE;
		}
	return FALSE;
}

void CSymDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSymDlg)
	DDX_LBString(pDX, IDC_SYMBOL_LIST, m_Symbol);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSymDlg, CDialog)
	//{{AFX_MSG_MAP(CSymDlg)
	ON_LBN_DBLCLK(IDC_SYMBOL_LIST, OnDblclkSymbolList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



//CSymDlg::OnDblclkSymbolList - causes dialog to close and return IDOK
// when the user double clicks in the symbol list box.
void CSymDlg::OnDblclkSymbolList() 
{
	if (UpdateData (TRUE)) EndDialog (IDOK);	
}
