﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>PurifyPlus Sample</title>
<script language="javascript" type="text/javascript">
</script>
</head>
<body>
    <form id="form1" runat="server">
    <div style="text-align: left">
        <span style="font-size: 24pt"><span style="color: #0000ff">
            ASP.NET Example for PurifyPlus<br />
            [Word Counter]<br />
        </span>
        </span>
        <asp:MultiView ID="MultiViewHelp" runat="server">
            <asp:View ID="ViewHelpLink" runat="server">
                <asp:LinkButton ID="LinkButtonHelp" runat="server" OnClick="LinkButtonHelp_Click">How to use this example</asp:LinkButton>
            </asp:View>
            <asp:View ID="ViewHelpPage" runat="server">
                <span style="font-size: 14pt"><strong>
                How to use this example<br />
                </strong></span>
                <br />
                This example demonstrates server side profiling for <a href="http://www.asp.net"
                    target="_blank">ASP NET</a> applications using <a href="http://www-306.ibm.com/software/awdtools/purifyplus/"
                        target="_blank">PurifyPlus</a>.
                <br />
                It also shows how to control PurifyPlus data collection from ASP NET code by using
                <a href="PureAPI.html" target="_blank">PureAPI </a>interface.<br />
                Please follow <a href="AspNetProfiling.aspx" target="_blank">this link</a> for information
                on how to enable the ASP NET profiling.<br />
                <br />
                First make sure you can run this example with no profiling enabled:<br />
                <ol>
                    <li>Make sure the "Use PureAPI' check box is disabled. This indicates there is no profiler
                        enabled.</li><li>Click the "Browse" button and open a text file.</li><li>Click the "Process" button. You should see the results table populated with words
                        found in the source file and number of times each word appears in the text.</li><li>Note that if you click the "Process" button again, the counters go up. This is because
                        this example has an intentional "memory leak". Hash table entries are not released,
                        thus holding the managed heap allocated for strings.</li><li>Enable ASP NET profiling on the server. Make sure PurifyPlus is running.</li><li>The "Use Pure API" check box must be active now, indicating the example is running in
                        the profiling mode.</li><li>Repeat steps 2 and 3. Make sure PurifyPlus is recording profiling data</li><li>Check "Fix Performance", "Fix Memory" and "Use PureAPI" buttons</li><li>Compare the results<br />
                <br />
                <asp:Button ID="ButtonCloseHelp" runat="server" OnClick="ButtonCloseHelp_Click" Text="Close Help" /></li></ol>
            </asp:View>
        </asp:MultiView><br />
        <asp:Panel ID="Panel2" runat="server" Height="81px" Width="534px" BackColor="Silver" BorderStyle="Groove">
            <asp:Label ID="Label1" runat="server" Text="Upload File for Processing"></asp:Label>
            &nbsp;
            <asp:FileUpload ID="FileUpload1" runat="server" Width="454px" />
            <asp:Button ID="ButtonProcess" runat="server" Height="21px" OnClick="ButtonProcess_Click"
                Text="Process" /><br />
            <asp:CheckBox ID="CheckBoxFixPerf" runat="server" Text="Fix Performance" />
            <asp:CheckBox ID="CheckBoxFixLeaks" runat="server" Text="Fix Memory" />
            <asp:CheckBox ID="CheckBoxPureApi" runat="server" EnableViewState="False" Text="Use PureAPI"
                Width="109px" /></asp:Panel>
        <asp:Label ID="LabelMsg" runat="server" Width="518px"></asp:Label><br />
        <asp:Button ID="ButtonWords" runat="server" Text="Sort By Words" Width="268px" OnClick="ButtonWords_Click" Height="24px" />
        <asp:Button ID="ButtonCounts" runat="server" Text="Sort By Counts" Width="268px" OnClick="ButtonCounts_Click" />
        <asp:Panel ID="Panel1" runat="server" Height="1px" Width="489px">
            <asp:Table ID="TableResults" runat="server" BorderStyle="Solid" GridLines="Both"
                Height="18px" Width="538px">
                <asp:TableRow runat="server" BackColor="Silver" ForeColor="Black">
                    <asp:TableCell runat="server">Words</asp:TableCell>
                    <asp:TableCell runat="server">Counts</asp:TableCell>
                </asp:TableRow>
            </asp:Table>
        </asp:Panel>
    
    </div>
    </form>
</body>
</html>
