//*
//* PURE_API.C
//*
//* | Licensed Materials - Use restricted, please refer to the "Samples" terms
//* | and conditions in the IBM International Program License Agreement (IPLA).  
//* (C) Copyright IBM Corporation. 1995, 2006. All Rights Reserved.
//*

/*
 * Header file of Pure API function declarations.
 *
 * Explicitly no copyright.
 * You may recompile and redistribute these definitions as required.
 */

#include <stddef.h>		// for size_t type definition

__declspec(dllexport) int __cdecl PurePrintf(const char *fmt, ...) { return 0; }
__declspec(dllexport) int __cdecl PurifyIsRunning(void) { return 0; }
__declspec(dllexport) int __cdecl PurifyPrintf(const char *fmt, ...) { return 0; }
__declspec(dllexport) size_t __cdecl PurifyNewInuse(void) { return 0; }
__declspec(dllexport) size_t __cdecl PurifyAllInuse(void) { return 0; }
__declspec(dllexport) size_t __cdecl PurifyClearInuse(void) { return 0; }
__declspec(dllexport) size_t __cdecl PurifyNewLeaks(void) { return 0; }
__declspec(dllexport) size_t __cdecl PurifyAllLeaks(void) { return 0; }
__declspec(dllexport) size_t __cdecl PurifyClearLeaks(void) { return 0; }
__declspec(dllexport) size_t __cdecl PurifyAllHandlesInuse(void) { return 0; }
__declspec(dllexport) size_t __cdecl PurifyNewHandlesInuse(void) { return 0; }
__declspec(dllexport) size_t __cdecl PurifyDescribe(void *addr) { return 0; }
__declspec(dllexport) int __cdecl PurifyWhatColors(void *addr, size_t size) { return 0; }
__declspec(dllexport) int __cdecl PurifyAssertIsReadable(const void *addr, size_t size) { return 1; }
__declspec(dllexport) int __cdecl PurifyAssertIsWritable(const void *addr, size_t size) { return 1; }
__declspec(dllexport) int __cdecl PurifyIsReadable(const void *addr, size_t size) { return 1; }
__declspec(dllexport) int __cdecl PurifyIsWritable(const void *addr, size_t size) { return 1; }
__declspec(dllexport) int __cdecl PurifyIsInitialized(const void *addr, size_t size) { return 1; }
__declspec(dllexport) int __cdecl PurifyRed(void *addr, size_t size) { return 0; }
__declspec(dllexport) int __cdecl PurifyGreen(void *addr, size_t size) { return 0; }
__declspec(dllexport) int __cdecl PurifyYellow(void *addr, size_t size) { return 0; }
__declspec(dllexport) int __cdecl PurifyBlue(void *addr, size_t size) { return 0; }
__declspec(dllexport) int __cdecl PurifyMarkAsInitialized(void *addr, size_t size) { return 0; }
__declspec(dllexport) int __cdecl PurifyMarkAsUninitialized(void *addr, size_t size) { return 0; }
__declspec(dllexport) int __cdecl PurifyMarkForTrap(void *addr, size_t size) { return 0; }
__declspec(dllexport) int __cdecl PurifyMarkForNoTrap(void *addr, size_t size) { return 0; }
__declspec(dllexport) int __cdecl PurifyHeapValidate(unsigned int hHeap, unsigned int dwFlags, const void *addr) { return 1; }
__declspec(dllexport) int __cdecl PurifySetLateDetectScanCounter(int counter) { return 0; };
__declspec(dllexport) int __cdecl PurifySetLateDetectScanInterval(int seconds) { return 0; };
__declspec(dllexport) int __cdecl QuantifyIsRunning(void) { return 0; }
__declspec(dllexport) int __cdecl QuantifyDisableRecordingData(void) { return 0; }
__declspec(dllexport) int __cdecl QuantifyStartRecordingData(void) { return 0; }
__declspec(dllexport) int __cdecl QuantifyStopRecordingData(void) { return 0; }
__declspec(dllexport) int __cdecl QuantifyClearData(void) { return 0; }
__declspec(dllexport) int __cdecl QuantifyIsRecordingData(void) { return 0; }
__declspec(dllexport) int __cdecl QuantifyAddAnnotation(char *str) { return 0; }
__declspec(dllexport) int __cdecl QuantifySaveData(void) { return 0; }
