//*
//* stockdoc.h
//*
//* | Licensed Materials - Use restricted, please refer to the "Samples" terms
//* | and conditions in the IBM International Program License Agreement (IPLA).  
//* (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//*

// Stockdoc.h : interface of the CStockDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CPosition : public CObject
{
public:
	int m_Shares, m_Price, m_Symbol;
	CString m_strDisplay;

	CPosition ();
	CPosition (int PSymbol, int PPrice, int PShares);
	CPosition (CPosition& PPos);
	CPosition& operator= (CPosition& rVal);
	void SetPrice (int PPrice);
};

class CStockDoc : public CDocument
{

public:
	CArray<CPosition, CPosition> m_Portfolio;
	CStockDoc();
	DECLARE_DYNCREATE(CStockDoc)

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStockDoc)
	//}}AFX_VIRTUAL

// Implementation
public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CStockDoc)
	afx_msg void OnTradeBuy();
	afx_msg void OnTradeSell();
	afx_msg void OnTradeShort();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

