//*
//* symdoc.h
//*
//* | Licensed Materials - Use restricted, please refer to the "Samples" terms
//* | and conditions in the IBM International Program License Agreement (IPLA).  
//* (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
//*

// symdoc.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// CSymDoc document
#define MAXTRANSACTIONS 0x1f
class CSymDoc : public CDocument
{
public:
	int m_Symbol, m_Prices [MAXTRANSACTIONS+1], m_Volumes [MAXTRANSACTIONS+1], 
		m_Last, m_PriceMin;
	char m_StrPrice [10];

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSymDoc)
	public:
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	CSymDoc ();
	DECLARE_DYNCREATE(CSymDoc)
	virtual ~CSymDoc();
	void InitSymbol (char* PSymbol); //initialize symbol and title bar
	void Transaction (int PPrice);	//add new transaction to history

protected: 
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CSymDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
