/*
 * hello.c -- Installation test program and cache builder.
 *
 * | Licensed Materials - Use restricted, please refer to the "Samples" terms
 * | and conditions in the IBM International Program License Agreement (IPLA).  
* (C) Copyright IBM Corporation. 1992, 2006. All Rights Reserved.
 *
 */

#include <windows.h>

WINAPI
WinMain(
    HINSTANCE  hInstance,	// handle of current instance
    HINSTANCE  hPrevInstance,	// handle of previous instance
    LPSTR  lpszCmdLine,	// address of command line
    int  nCmdShow 	// show state of window
   )
{
    int i;
    size_t length;
    char *string1 = "Hello, Windows";
    char *string2 = malloc(10);

    length = strlen(string2);               // UMR because string2 is not initialized.

    for (i = 0; string1[i] != '\0'; i++) {
        string2[i] = string1[i];            // ABW's generated on this line.
    }
    length = strlen(string2);               // ABR generated on this line.

    MessageBox(NULL, "        Hello, Windows", "The Windows Hello Dialog", MB_OK | MB_ICONINFORMATION);

    return 0;
}

